#pragma once

// solanaceae port of sha1 fts for NGCFT1

#include <solanaceae/message3/registry_message_model.hpp>
#include <solanaceae/tox_contacts/tox_contact_model2.hpp>

#include "./ngcft1.hpp"

class SHA1_NGCFT1 : public RegistryMessageModelEventI, public NGCFT1EventI {
	RegistryMessageModel& _rmm;
	NGCFT1EventProviderI& _nftep;
	ToxContactModel2& _tcm;

	public:
		SHA1_NGCFT1(
			RegistryMessageModel& rmm,
			NGCFT1EventProviderI& nftep,
			ToxContactModel2& tcm
		);

		//void iterate(float delta);

	protected:
		bool onEvent(const Events::NGCFT1_recv_request&) override;
		bool onEvent(const Events::NGCFT1_recv_init&) override;
		bool onEvent(const Events::NGCFT1_recv_data&) override;
		bool onEvent(const Events::NGCFT1_send_data&) override; // const?
};

